diff --git a/gcc/tree-ssanames.c b/gcc/tree-ssanames.c
index 0a405ce..c5227b1 100644
--- a/gcc/tree-ssanames.c
+++ b/gcc/tree-ssanames.c
@@ -440,22 +440,32 @@ release_dead_ssa_names (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_release_ssa_names =
+class pass_release_ssa_names : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "release_ssa",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  release_dead_ssa_names,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SSA_OTHER,			/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  TODO_remove_unused_locals,		/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_release_ssa_names(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "release_ssa",
+		      OPTGROUP_NONE,
+		      TV_TREE_SSA_OTHER,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(TODO_remove_unused_locals),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return release_dead_ssa_names (); }
+
+}; // class pass_release_ssa_names
+
+gimple_opt_pass *
+make_pass_release_ssa_names (context &ctxt)
+{
+  return new pass_release_ssa_names (ctxt);
+}
diff --git a/gcc/tree-stdarg.c b/gcc/tree-stdarg.c
index 8ad9fc2..94da9e3 100644
--- a/gcc/tree-stdarg.c
+++ b/gcc/tree-stdarg.c
@@ -985,22 +985,32 @@ finish:
 }
 
 
-struct gimple_opt_pass pass_stdarg =
+class pass_stdarg : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "stdarg",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_optimize_stdarg,			/* gate */
-  execute_optimize_stdarg,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+public:
+  pass_stdarg(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "stdarg",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_optimize_stdarg (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_optimize_stdarg (); }
+
+}; // class pass_stdarg
+
+gimple_opt_pass *
+make_pass_stdarg (context &ctxt)
+{
+  return new pass_stdarg (ctxt);
+}
diff --git a/gcc/tree-switch-conversion.c b/gcc/tree-switch-conversion.c
index 3fffdf7..4ed2c21 100644
--- a/gcc/tree-switch-conversion.c
+++ b/gcc/tree-switch-conversion.c
@@ -1460,25 +1460,32 @@ switchconv_gate (void)
   return flag_tree_switch_conversion != 0;
 }
 
-struct gimple_opt_pass pass_convert_switch =
+class pass_convert_switch : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "switchconv",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  switchconv_gate,			/* gate */
-  do_switchconv,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SWITCH_CONVERSION,		/* tv_id */
-  PROP_cfg | PROP_ssa,	                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa 
-  | TODO_verify_ssa
-  | TODO_verify_stmts
-  | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_convert_switch(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "switchconv",
+		      OPTGROUP_NONE,
+		      TV_TREE_SWITCH_CONVERSION,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_stmts | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return switchconv_gate (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return do_switchconv (); }
+
+}; // class pass_convert_switch
+
+gimple_opt_pass *
+make_pass_convert_switch (context &ctxt)
+{
+  return new pass_convert_switch (ctxt);
+}
diff --git a/gcc/tree-tailcall.c b/gcc/tree-tailcall.c
index c6581dc..40724a9 100644
--- a/gcc/tree-tailcall.c
+++ b/gcc/tree-tailcall.c
@@ -1048,42 +1048,62 @@ execute_tail_calls (void)
   return tree_optimize_tail_calls_1 (true);
 }
 
-struct gimple_opt_pass pass_tail_recursion =
+class pass_tail_recursion : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "tailr",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tail_calls,			/* gate */
-  execute_tail_recursion,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
+public:
+  pass_tail_recursion(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tailr",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tail_calls (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_tail_recursion (); }
+
+}; // class pass_tail_recursion
+
+gimple_opt_pass *
+make_pass_tail_recursion (context &ctxt)
+{
+  return new pass_tail_recursion (ctxt);
+}
 
-struct gimple_opt_pass pass_tail_calls =
+class pass_tail_calls : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "tailc",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tail_calls,			/* gate */
-  execute_tail_calls,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
+public:
+  pass_tail_calls(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tailc",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tail_calls (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_tail_calls (); }
+
+}; // class pass_tail_calls
+
+gimple_opt_pass *
+make_pass_tail_calls (context &ctxt)
+{
+  return new pass_tail_calls (ctxt);
+}
diff --git a/gcc/tree-vect-generic.c b/gcc/tree-vect-generic.c
index dbad6d9..3f1d60a 100644
--- a/gcc/tree-vect-generic.c
+++ b/gcc/tree-vect-generic.c
@@ -1500,50 +1500,64 @@ expand_vector_operations (void)
   return cfg_changed ? TODO_cleanup_cfg : 0;
 }
 
-struct gimple_opt_pass pass_lower_vector =
+class pass_lower_vector : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "veclower",				/* name */
-  OPTGROUP_VEC,                         /* optinfo_flags */
-  gate_expand_vector_operations_ssa,    /* gate */
-  expand_vector_operations,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  PROP_gimple_lvec,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa	                /* todo_flags_finish */
-    | TODO_verify_ssa
-    | TODO_verify_stmts | TODO_verify_flow
-    | TODO_cleanup_cfg
- }
-};
-
-struct gimple_opt_pass pass_lower_vector_ssa =
+public:
+  pass_lower_vector(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "veclower",
+		      OPTGROUP_VEC,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_gimple_lvec),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_stmts | TODO_verify_flow | TODO_cleanup_cfg)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_expand_vector_operations_ssa (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return expand_vector_operations (); }
+
+}; // class pass_lower_vector
+
+gimple_opt_pass *
+make_pass_lower_vector (context &ctxt)
 {
- {
-  GIMPLE_PASS,
-  "veclower2",				/* name */
-  OPTGROUP_VEC,                         /* optinfo_flags */
-  0,	                                /* gate */
-  expand_vector_operations,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  PROP_gimple_lvec,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa	                /* todo_flags_finish */
-    | TODO_verify_ssa
-    | TODO_verify_stmts | TODO_verify_flow
-    | TODO_cleanup_cfg
- }
-};
+  return new pass_lower_vector (ctxt);
+}
+
+class pass_lower_vector_ssa : public gimple_opt_pass
+{
+public:
+  pass_lower_vector_ssa(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "veclower2",
+		      OPTGROUP_VEC,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_gimple_lvec),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_stmts | TODO_verify_flow | TODO_cleanup_cfg)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return expand_vector_operations (); }
+
+}; // class pass_lower_vector_ssa
+
+gimple_opt_pass *
+make_pass_lower_vector_ssa (context &ctxt)
+{
+  return new pass_lower_vector_ssa (ctxt);
+}
 
 #include "gt-tree-vect-generic.h"
diff --git a/gcc/tree-vectorizer.c b/gcc/tree-vectorizer.c
index 0227d08..187aeff 100644
--- a/gcc/tree-vectorizer.c
+++ b/gcc/tree-vectorizer.c
@@ -197,28 +197,35 @@ gate_vect_slp (void)
           || flag_tree_slp_vectorize == 1);
 }
 
-struct gimple_opt_pass pass_slp_vectorize =
+class pass_slp_vectorize : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "slp",                                /* name */
-  OPTGROUP_LOOP
-  | OPTGROUP_VEC,                       /* optinfo_flags */
-  gate_vect_slp,                        /* gate */
-  execute_vect_slp,                     /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_TREE_SLP_VECTORIZATION,            /* tv_id */
-  PROP_ssa | PROP_cfg,                  /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_ssa
-    | TODO_update_ssa
-    | TODO_verify_stmts                 /* todo_flags_finish */
- }
-};
+public:
+  pass_slp_vectorize(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "slp",
+		      OPTGROUP_LOOP | OPTGROUP_VEC,
+		      TV_TREE_SLP_VECTORIZATION,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_update_ssa | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_vect_slp (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_vect_slp (); }
+
+}; // class pass_slp_vectorize
+
+gimple_opt_pass *
+make_pass_slp_vectorize (context &ctxt)
+{
+  return new pass_slp_vectorize (ctxt);
+}
 
 
 /* Increase alignment of global arrays to improve vectorization potential.
@@ -272,23 +279,32 @@ gate_increase_alignment (void)
 }
 
 
-struct simple_ipa_opt_pass pass_ipa_increase_alignment =
+class pass_ipa_increase_alignment : public simple_ipa_opt_pass
 {
- {
-  SIMPLE_IPA_PASS,
-  "increase_alignment",                 /* name */
-  OPTGROUP_LOOP
-  | OPTGROUP_VEC,                       /* optinfo_flags */
-  gate_increase_alignment,              /* gate */
-  increase_alignment,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IPA_OPT,                           /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_ipa_increase_alignment(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "increase_alignment",
+			  OPTGROUP_LOOP | OPTGROUP_VEC,
+			  TV_IPA_OPT,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_increase_alignment (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return increase_alignment (); }
+
+}; // class pass_ipa_increase_alignment
+
+simple_ipa_opt_pass *
+make_pass_ipa_increase_alignment (context &ctxt)
+{
+  return new pass_ipa_increase_alignment (ctxt);
+}
diff --git a/gcc/tree-vrp.c b/gcc/tree-vrp.c
index 5b4321a..2f5a4fd 100644
--- a/gcc/tree-vrp.c
+++ b/gcc/tree-vrp.c
@@ -9395,25 +9395,32 @@ gate_vrp (void)
   return flag_tree_vrp != 0;
 }
 
-struct gimple_opt_pass pass_vrp =
-{
- {
-  GIMPLE_PASS,
-  "vrp",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_vrp,				/* gate */
-  execute_vrp,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_VRP,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_update_ssa
-    | TODO_verify_ssa
-    | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+class pass_vrp : public gimple_opt_pass
+{
+public:
+  pass_vrp(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "vrp",
+		      OPTGROUP_NONE,
+		      TV_TREE_VRP,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_update_ssa | TODO_verify_ssa | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_vrp (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_vrp (); }
+
+}; // class pass_vrp
+
+gimple_opt_pass *
+make_pass_vrp (context &ctxt)
+{
+  return new pass_vrp (ctxt);
+}
diff --git a/gcc/tree.c b/gcc/tree.c
index d8f2424..7821dd9 100644
--- a/gcc/tree.c
+++ b/gcc/tree.c
@@ -5308,25 +5308,35 @@ free_lang_data (void)
 }
 
 
-struct simple_ipa_opt_pass pass_ipa_free_lang_data =
-{
- {
-  SIMPLE_IPA_PASS,
-  "*free_lang_data",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  free_lang_data,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_FREE_LANG_DATA,		/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_ipa_free_lang_data : public simple_ipa_opt_pass
+{
+public:
+  pass_ipa_free_lang_data(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "*free_lang_data",
+			  OPTGROUP_NONE,
+			  TV_IPA_FREE_LANG_DATA,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return free_lang_data (); }
+
+}; // class pass_ipa_free_lang_data
+
+simple_ipa_opt_pass *
+make_pass_ipa_free_lang_data (context &ctxt)
+{
+  return new pass_ipa_free_lang_data (ctxt);
+}
 
 /* The backbone of is_attribute_p().  ATTR_LEN is the string length of
    ATTR_NAME.  Also used internally by remove_attribute().  */
diff --git a/gcc/tsan.c b/gcc/tsan.c
index c02e100..4c09af8 100644
--- a/gcc/tsan.c
+++ b/gcc/tsan.c
@@ -730,25 +730,35 @@ tsan_finish_file (void)
 
 /* The pass descriptor.  */
 
-struct gimple_opt_pass pass_tsan =
+class pass_tsan : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "tsan",				/* name  */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  tsan_gate,				/* gate  */
-  tsan_pass,				/* execute  */
-  NULL,					/* sub  */
-  NULL,					/* next  */
-  0,					/* static_pass_number  */
-  TV_NONE,				/* tv_id  */
-  PROP_ssa | PROP_cfg,			/* properties_required  */
-  0,					/* properties_provided  */
-  0,					/* properties_destroyed  */
-  0,					/* todo_flags_start  */
-  TODO_verify_all | TODO_update_ssa	/* todo_flags_finish  */
- }
-};
+public:
+  pass_tsan(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tsan",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_all | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return tsan_gate (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tsan_pass (); }
+
+}; // class pass_tsan
+
+gimple_opt_pass *
+make_pass_tsan (context &ctxt)
+{
+  return new pass_tsan (ctxt);
+}
 
 static bool
 tsan_gate_O0 (void)
@@ -756,22 +766,32 @@ tsan_gate_O0 (void)
   return flag_tsan != 0 && !optimize;
 }
 
-struct gimple_opt_pass pass_tsan_O0 =
+class pass_tsan_O0 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "tsan0",				/* name  */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  tsan_gate_O0,				/* gate  */
-  tsan_pass,				/* execute  */
-  NULL,					/* sub  */
-  NULL,					/* next  */
-  0,					/* static_pass_number  */
-  TV_NONE,				/* tv_id  */
-  PROP_ssa | PROP_cfg,			/* properties_required  */
-  0,					/* properties_provided  */
-  0,					/* properties_destroyed  */
-  0,					/* todo_flags_start  */
-  TODO_verify_all | TODO_update_ssa	/* todo_flags_finish  */
- }
-};
+public:
+  pass_tsan_O0(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tsan0",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_all | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return tsan_gate_O0 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tsan_pass (); }
+
+}; // class pass_tsan_O0
+
+gimple_opt_pass *
+make_pass_tsan_O0 (context &ctxt)
+{
+  return new pass_tsan_O0 (ctxt);
+}
diff --git a/gcc/var-tracking.c b/gcc/var-tracking.c
index 337af5a..a83587c 100644
--- a/gcc/var-tracking.c
+++ b/gcc/var-tracking.c
@@ -10222,23 +10222,32 @@ gate_handle_var_tracking (void)
 
 
 
-struct rtl_opt_pass pass_variable_tracking =
-{
- {
-  RTL_PASS,
-  "vartrack",                           /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_var_tracking,             /* gate */
-  variable_tracking_main,               /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_VAR_TRACKING,                      /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing
-   | TODO_verify_flow                   /* todo_flags_finish */
- }
-};
+class pass_variable_tracking : public rtl_opt_pass
+{
+public:
+  pass_variable_tracking(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "vartrack",
+		   OPTGROUP_NONE,
+		   TV_VAR_TRACKING,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_var_tracking (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return variable_tracking_main (); }
+
+}; // class pass_variable_tracking
+
+rtl_opt_pass *
+make_pass_variable_tracking (context &ctxt)
+{
+  return new pass_variable_tracking (ctxt);
+}
diff --git a/gcc/web.c b/gcc/web.c
index d09d1d5..1d2b36d 100644
--- a/gcc/web.c
+++ b/gcc/web.c
@@ -439,22 +439,32 @@ web_main (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_web =
+class pass_web : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "web",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_web,                      /* gate */
-  web_main,		                /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_WEB,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing  /* todo_flags_finish */
- }
-};
+public:
+  pass_web(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "web",
+		   OPTGROUP_NONE,
+		   TV_WEB,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_web (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return web_main (); }
+
+}; // class pass_web
+
+rtl_opt_pass *
+make_pass_web (context &ctxt)
+{
+  return new pass_web (ctxt);
+}
-- 
1.7.11.7

